BeanSerializerBase
Date: 2016-12-04

com.fasterxml.jackson.databind.ser.std

## Class BeanSerializerBase

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<java.lang.Object>
    - - com.fasterxml.jackson.databind.ser.std.BeanSerializerBase

- All Implemented Interfaces:
    JsonFormatVisitable, SchemaAware, ContextualSerializer, ResolvableSerializer, java.io.Serializable
  Direct Known Subclasses:
    BeanAsArraySerializer, BeanSerializer, UnwrappingBeanSerializer

      public abstract class BeanSerializerBase
      extends StdSerializer<java.lang.Object>
      implements ContextualSerializer, ResolvableSerializer, JsonFormatVisitable, SchemaAware

  Base class both for the standard bean serializer, and couple of variants that only differ in small details. Can be used for custom bean serializers as well, although that is not the primary design goal.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected AnyGetterWriter` | `_anyGetterWriter` Handler for `JsonAnyGetter` annotated properties
    `protected BeanPropertyWriter[]` | `_filteredProps` Optional filters used to suppress output of properties that are only to be included in certain views
    `protected ObjectIdWriter` | `_objectIdWriter` If this POJO can be alternatively serialized using just an object id to denote a reference to previously serialized object, this Object will handle details.
    `protected java.lang.Object` | `_propertyFilterId` Id of the bean property filter to use, if any; null if none.
    `protected BeanPropertyWriter[]` | `_props` Writers used for outputting actual property values
    `protected com.fasterxml.jackson.annotation.JsonFormat.Shape` | `_serializationShape` Requested shape from bean class annotations.
    `protected AnnotatedMember` | `_typeId` If using custom type ids (usually via getter, or field), this is the reference to that member.
    `protected static PropertyName` | `NAME_FOR_OBJECT_REF`
    `protected static BeanPropertyWriter[]` | `NO_PROPS`

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `_handledType`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `BeanSerializerBase(BeanSerializerBase src)` Copy-constructor that is useful for sub-classes that just want to copy all super-class properties without modifications.
    `` | `BeanSerializerBase(BeanSerializerBase src, BeanPropertyWriter[] properties, BeanPropertyWriter[] filteredProperties)`
    `protected` | `BeanSerializerBase(BeanSerializerBase src, NameTransformer unwrapper)` Copy-constructor that will also rename properties with given prefix (if it's non-empty)
    `protected` | `BeanSerializerBase(BeanSerializerBase src, ObjectIdWriter objectIdWriter)`
    `protected` | `BeanSerializerBase(BeanSerializerBase src, ObjectIdWriter objectIdWriter, java.lang.Object filterId)`
    `protected` | `BeanSerializerBase(BeanSerializerBase src, java.util.Set<java.lang.String> toIgnore)`
    `protected` | `BeanSerializerBase(BeanSerializerBase src, java.lang.String[] toIgnore)` Deprecated.
    `protected` | `BeanSerializerBase(JavaType type, BeanSerializerBuilder builder, BeanPropertyWriter[] properties, BeanPropertyWriter[] filteredProperties)` Constructor used by `BeanSerializerBuilder` to create an instance

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.String` | `_customTypeId(java.lang.Object bean)`
    `protected void` | `_serializeObjectId(java.lang.Object bean, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, TypeSerializer typeSer, WritableObjectId objectId)`
    `protected void` | `_serializeWithObjectId(java.lang.Object bean, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, boolean startEndObject)`
    `protected void` | `_serializeWithObjectId(java.lang.Object bean, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, TypeSerializer typeSer)`
    `void` | `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
    `protected abstract BeanSerializerBase` | `asArraySerializer()` Mutant factory for creating a variant that output POJO as a JSON Array.
    `JsonSerializer<?>` | `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
    `protected JsonSerializer<java.lang.Object>` | `findConvertingSerializer(SerializerProvider provider, BeanPropertyWriter prop)` Helper method that can be used to see if specified property is annotated to indicate use of a converter for property value (in case of container types, it is container type itself, not key or content type).
    `JsonNode` | `getSchema(SerializerProvider provider, java.lang.reflect.Type typeHint)` Deprecated.
    `java.util.Iterator<PropertyWriter>` | `properties()` Accessor for iterating over logical properties that the type handled by this serializer has, from serialization perspective.
    `void` | `resolve(SerializerProvider provider)` We need to implement `ResolvableSerializer` to be able to properly handle cyclic type references.
    `abstract void` | `serialize(java.lang.Object bean, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
    `protected void` | `serializeFields(java.lang.Object bean, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider)`
    `protected void` | `serializeFieldsFiltered(java.lang.Object bean, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider)` Alternative serialization method that gets called when there is a `PropertyFilter` that needs to be called to determine which properties are to be serialized (and possibly how)
    `void` | `serializeWithType(java.lang.Object bean, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
    `boolean` | `usesObjectId()` Method that can be called to see whether this serializer instance will use Object Id to handle cyclic references.
    `abstract BeanSerializerBase` | `withFilterId(java.lang.Object filterId)` Mutant factory used for creating a new instance with different filter id (used with `JsonFilter` annotation)
    `protected abstract BeanSerializerBase` | `withIgnorals(java.util.Set<java.lang.String> toIgnore)` Mutant factory used for creating a new instance with additional set of properties to ignore (from properties this instance otherwise has)
    `protected BeanSerializerBase` | `withIgnorals(java.lang.String[] toIgnore)` Deprecated. since 2.8
    `abstract BeanSerializerBase` | `withObjectIdWriter(ObjectIdWriter objectIdWriter)` Mutant factory used for creating a new instance with different `ObjectIdWriter`.

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `createObjectNode, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `getDelegatee, isEmpty, isEmpty, isUnwrappingSerializer, replaceDelegatee, unwrappingSerializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.fasterxml.jackson.databind.jsonschema.SchemaAware

      `getSchema`

- - ### Field Detail

    - #### NAME_FOR_OBJECT_REF

          protected static final PropertyName NAME_FOR_OBJECT_REF

    - #### NO_PROPS

          protected static final BeanPropertyWriter[] NO_PROPS

    - #### _props

          protected final BeanPropertyWriter[] _props

      Writers used for outputting actual property values

    - #### _filteredProps

          protected final BeanPropertyWriter[] _filteredProps

      Optional filters used to suppress output of properties that are only to be included in certain views

    - #### _anyGetterWriter

          protected final AnyGetterWriter _anyGetterWriter

      Handler for `JsonAnyGetter` annotated properties

    - #### _propertyFilterId

          protected final java.lang.Object _propertyFilterId

      Id of the bean property filter to use, if any; null if none.

    - #### _typeId

          protected final AnnotatedMember _typeId

      If using custom type ids (usually via getter, or field), this is the reference to that member.

    - #### _objectIdWriter

          protected final ObjectIdWriter _objectIdWriter

      If this POJO can be alternatively serialized using just an object id to denote a reference to previously serialized object, this Object will handle details.

    - #### _serializationShape

          protected final com.fasterxml.jackson.annotation.JsonFormat.Shape _serializationShape

      Requested shape from bean class annotations.

  - ### Constructor Detail

    - #### BeanSerializerBase

          protected BeanSerializerBase(JavaType type,
                            BeanSerializerBuilder builder,
                            BeanPropertyWriter[] properties,
                            BeanPropertyWriter[] filteredProperties)

      Constructor used by `BeanSerializerBuilder` to create an instance
      Parameters:
        `type` - Nominal type of values handled by this serializer
        `builder` - Builder for accessing other collected information

    - #### BeanSerializerBase

          public BeanSerializerBase(BeanSerializerBase src,
                            BeanPropertyWriter[] properties,
                            BeanPropertyWriter[] filteredProperties)

    - #### BeanSerializerBase

          protected BeanSerializerBase(BeanSerializerBase src,
                            ObjectIdWriter objectIdWriter)

    - #### BeanSerializerBase

          protected BeanSerializerBase(BeanSerializerBase src,
                            ObjectIdWriter objectIdWriter,
                            java.lang.Object filterId)

      Since:
        2.3

    - #### BeanSerializerBase

          @Deprecated
          protected BeanSerializerBase(BeanSerializerBase src,
                                       java.lang.String[] toIgnore)

      Deprecated.

    - #### BeanSerializerBase

          protected BeanSerializerBase(BeanSerializerBase src,
                            java.util.Set<java.lang.String> toIgnore)

    - #### BeanSerializerBase

          protected BeanSerializerBase(BeanSerializerBase src)

      Copy-constructor that is useful for sub-classes that just want to copy all super-class properties without modifications.

    - #### BeanSerializerBase

          protected BeanSerializerBase(BeanSerializerBase src,
                            NameTransformer unwrapper)

      Copy-constructor that will also rename properties with given prefix (if it's non-empty)

  - ### Method Detail

    - #### withObjectIdWriter

          public abstract BeanSerializerBase withObjectIdWriter(ObjectIdWriter objectIdWriter)

      Mutant factory used for creating a new instance with different `ObjectIdWriter`.
      Since:
        2.0

    - #### withIgnorals

          protected abstract BeanSerializerBase withIgnorals(java.util.Set<java.lang.String> toIgnore)

      Mutant factory used for creating a new instance with additional set of properties to ignore (from properties this instance otherwise has)
      Since:
        2.8

    - #### withIgnorals

          @Deprecated
          protected BeanSerializerBase withIgnorals(java.lang.String[] toIgnore)

      Deprecated. since 2.8
      Mutant factory used for creating a new instance with additional set of properties to ignore (from properties this instance otherwise has)

    - #### asArraySerializer

          protected abstract BeanSerializerBase asArraySerializer()

      Mutant factory for creating a variant that output POJO as a JSON Array. Implementations may ignore this request if output as array is not possible (either at all, or reliably).
      Since:
        2.1

    - #### withFilterId

          public abstract BeanSerializerBase withFilterId(java.lang.Object filterId)

      Mutant factory used for creating a new instance with different filter id (used with `JsonFilter` annotation)
      Overrides:
        `withFilterId` in class `JsonSerializer<java.lang.Object>`
      Since:
        2.3

    - #### resolve

          public void resolve(SerializerProvider provider)
                       throws JsonMappingException

      We need to implement `ResolvableSerializer` to be able to properly handle cyclic type references.
      Specified by:
        `resolve` in interface `ResolvableSerializer`
      Parameters:
        `provider` - Provider that has constructed serializer this method is called on.
      Throws:
        `JsonMappingException`

    - #### findConvertingSerializer

          protected JsonSerializer<java.lang.Object> findConvertingSerializer(SerializerProvider provider,
                                                                  BeanPropertyWriter prop)
                                                                       throws JsonMappingException

      Helper method that can be used to see if specified property is annotated to indicate use of a converter for property value (in case of container types, it is container type itself, not key or content type).
      Throws:
        `JsonMappingException`
      Since:
        2.2

    - #### createContextual

          public JsonSerializer<?> createContextual(SerializerProvider provider,
                                           BeanProperty property)
                                             throws JsonMappingException

      Description copied from interface: `ContextualSerializer`
      Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Specified by:
        `createContextual` in interface `ContextualSerializer`
      Parameters:
        `provider` - Serializer provider to use for accessing config, other serializers
        `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
      Returns:
        Serializer to use for serializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### properties

          public java.util.Iterator<PropertyWriter> properties()

      Description copied from class: `JsonSerializer`
      Accessor for iterating over logical properties that the type handled by this serializer has, from serialization perspective. Actual type of properties, if any, will be `BeanPropertyWriter`. Of standard Jackson serializers, only `BeanSerializer` exposes properties.
      Overrides:
        `properties` in class `JsonSerializer<java.lang.Object>`

    - #### usesObjectId

          public boolean usesObjectId()

      Description copied from class: `JsonSerializer`
      Method that can be called to see whether this serializer instance will use Object Id to handle cyclic references.
      Overrides:
        `usesObjectId` in class `JsonSerializer<java.lang.Object>`

    - #### serialize

          public abstract void serialize(java.lang.Object bean,
                       com.fasterxml.jackson.core.JsonGenerator gen,
                       SerializerProvider provider)
                                  throws java.io.IOException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles.
      Specified by:
        `serialize` in class `StdSerializer<java.lang.Object>`
      Parameters:
        `bean` - Value to serialize; can not be null.
        `gen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
      Throws:
        `java.io.IOException`

    - #### serializeWithType

          public void serializeWithType(java.lang.Object bean,
                               com.fasterxml.jackson.core.JsonGenerator gen,
                               SerializerProvider provider,
                               TypeSerializer typeSer)
                                 throws java.io.IOException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

      Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

      For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

            // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
            typeSer.writeTypePrefixForScalar(value, gen);
            serialize(value, gen, provider);
            typeSer.writeTypeSuffixForScalar(value, gen);

      and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY`/`END-ARRAY` and `START-OBJECT`/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.
      Overrides:
        `serializeWithType` in class `JsonSerializer<java.lang.Object>`
      Parameters:
        `bean` - Value to serialize; can not be null.
        `gen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
        `typeSer` - Type serializer to use for including type information
      Throws:
        `java.io.IOException`

    - #### _serializeWithObjectId

          protected final void _serializeWithObjectId(java.lang.Object bean,
                                    com.fasterxml.jackson.core.JsonGenerator gen,
                                    SerializerProvider provider,
                                    boolean startEndObject)
                                               throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _serializeWithObjectId

          protected final void _serializeWithObjectId(java.lang.Object bean,
                                    com.fasterxml.jackson.core.JsonGenerator gen,
                                    SerializerProvider provider,
                                    TypeSerializer typeSer)
                                               throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _serializeObjectId

          protected void _serializeObjectId(java.lang.Object bean,
                                com.fasterxml.jackson.core.JsonGenerator gen,
                                SerializerProvider provider,
                                TypeSerializer typeSer,
                                WritableObjectId objectId)
                                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _customTypeId

          protected final java.lang.String _customTypeId(java.lang.Object bean)

    - #### serializeFields

          protected void serializeFields(java.lang.Object bean,
                             com.fasterxml.jackson.core.JsonGenerator gen,
                             SerializerProvider provider)
                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### serializeFieldsFiltered

          protected void serializeFieldsFiltered(java.lang.Object bean,
                                     com.fasterxml.jackson.core.JsonGenerator gen,
                                     SerializerProvider provider)
                                          throws java.io.IOException,
                                                 com.fasterxml.jackson.core.JsonGenerationException

      Alternative serialization method that gets called when there is a `PropertyFilter` that needs to be called to determine which properties are to be serialized (and possibly how)
      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonGenerationException`

    - #### getSchema

          @Deprecated
          public JsonNode getSchema(SerializerProvider provider,
                                      java.lang.reflect.Type typeHint)
                             throws JsonMappingException

      Deprecated.
      Description copied from class: `StdSerializer`
      Default implementation simply claims type is "string"; usually overriden by custom serializers.
      Specified by:
        `getSchema` in interface `SchemaAware`
      Overrides:
        `getSchema` in class `StdSerializer<java.lang.Object>`
      Parameters:
        `provider` - The serializer provider.
        `typeHint` - A hint about the type.
      Returns:
        Json-schema for this serializer.
      Throws:
        `JsonMappingException`

    - #### acceptJsonFormatVisitor

          public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                                     JavaType typeHint)
                                       throws JsonMappingException

      Description copied from class: `StdSerializer`
      Default implementation specifies no format. This behavior is usually overriden by custom serializers.
      Specified by:
        `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
      Overrides:
        `acceptJsonFormatVisitor` in class `StdSerializer<java.lang.Object>`
        `typeHint` - Type of element (entity like property) being visited
      Throws:
        `JsonMappingException`